//+------------------------------------------------------------------+
//|                                      .mq4 |
//|                                                            |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""

extern double PercentProfit     =40.0;//  
extern double PercentLoss       =-15.0;//  
extern double PercentTrailing   =20.0;//    ,   0  .
extern double Step              =5.0;//  
extern int    Magic             =777;

bool SigCloseOrders;
double _PercentTrailing,_PercentLoss;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
_PercentTrailing=PercentTrailing;
_PercentLoss=PercentLoss;    
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
  if(IsConnected()==false){ObjectSetText("TimeExpert","     ",8,"Verdana",Yellow);return(0);}
  if(IsExpertEnabled()==false){ObjectSetText("TimeExpert","     ",8,"Verdana",Yellow);return(0);}
  if(IsTradeAllowed()==false){ObjectSetText("TimeExpert"," . .    . . . ",8,"Verdana",Yellow);return(0);}
  if(IsTradeContextBusy()==true){ObjectSetText("TimeExpert","     ",8,"Verdana",Yellow);return(0);}
//----  
  if(TotalOrders()==0)
    {
    SigCloseOrders=false;
    _PercentTrailing=PercentTrailing;
    _PercentLoss=PercentLoss;
    }
//----
  if(PercentTrailing!=0 && SigCloseOrders==false)
    {
    if((EquityAccount()/AccountBalance()-1)*100>=_PercentTrailing+Step)
      {
      _PercentTrailing=_PercentTrailing+Step;
      _PercentLoss=(EquityAccount()/AccountBalance()-1)*100-PercentTrailing;
      }
    }
//----
  if(SigCloseOrders==false && 
    ((EquityAccount()/AccountBalance()-1)*100>=PercentProfit ||
     (EquityAccount()/AccountBalance()-1)*100<=_PercentLoss))
    {
    SigCloseOrders=true;
    }
//----
  if(SigCloseOrders==true && TotalOrders()>0)
    {
    CloseOrders();
    }
//----
  Comment(" ",DoubleToStr((EquityAccount()/AccountBalance()-1)*100,2),
          "% \n ",PercentProfit,"%  ",_PercentLoss,"%");
//----
   return(0);
  }
//+------------------------------------------------------------------+
int TotalOrders()
  {
  int order;
   for(int pos=OrdersTotal()-1;pos>=0;pos--)
    {
    if(OrderSelect(pos,SELECT_BY_POS,MODE_TRADES)==true)
      {
      if(OrderType()<=OP_SELL && OrderMagicNumber()==Magic)
        {
        order++;             
        }
      }
    else Print("         (",GetLastError(),")");
    }
  return(order);
  }
//+------------------------------------------------------------------+
void CloseOrders()
  {
  for(int pos=OrdersTotal()-1;pos>=0;pos--)
    {
    if(OrderSelect(pos,SELECT_BY_POS,MODE_TRADES)==true)
      {
      if(OrderType()<=OP_SELL && OrderMagicNumber()==Magic)
        {
        OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),5,CLR_NONE);             
        }
      }
    else Print("         (",GetLastError(),")");
    }
  }
//+------------------------------------------------------------------+
double EquityAccount()
  {
  double Profit;
   for(int pos=OrdersTotal()-1;pos>=0;pos--)
    {
    if(OrderSelect(pos,SELECT_BY_POS,MODE_TRADES)==true)
      {
      if(OrderType()<=OP_SELL && OrderMagicNumber()==Magic)
        {
        Profit+=OrderSwap()+OrderProfit();             
        }
      }
    else Print("         (",GetLastError(),")");
    }
  return(Profit+AccountBalance());
  }